//+------------------------------------------------------------------+
//|                                            OnlyPivot_Session.mq4 |
//|                                                     David Willis |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//#property indicator_color2 Magenta
//#property indicator_color3 Blue

//---- input parameters
//extern int CountBars = 300;
extern int     TYO_open = 0; // the Hour to start
extern int     LON_open = 8;
extern int     NYC_open = 13;



//---- buffers
double ExtMapBuffer1[];
//double ExtMapBuffer2[];
//double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
//   SetIndexStyle(1,DRAW_LINE);
//   SetIndexBuffer(1,ExtMapBuffer2);
//   SetIndexStyle(2,DRAW_LINE);
//   SetIndexBuffer(2,ExtMapBuffer3);
   
 //  SetIndexLabel(0,"Previous Day Pivot");
 //  SetIndexLabel(1,"Floating current pivot"); 

  return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int session(int i)
{
 int hour=TimeHour(iTime(NULL,0,i));
 int session=0;
      // find session....1=tokyo,2=london,3=nyc
      
      if(TYO_open < LON_open)
      {
       if(hour>=TYO_open && hour<LON_open){session=1;}
      }
      else
      {
       if(hour>=TYO_open || hour<LON_open){session=1;}
      }
      if(LON_open < NYC_open)
      {
       if(hour>=LON_open && hour<NYC_open){session=2;}
      }
      else
      {
       if(hour>=LON_open || hour<NYC_open){session=2;}
      }
      if(NYC_open < TYO_open)
      {
       if(hour>=NYC_open && hour<TYO_open){session=3;}
      }
      else
      {
       if(hour>=NYC_open || hour<TYO_open){session=3;}
      }
      
 return(session);
 }    
  
int start()
  {
     double pivot;
     int high,low,close;
     int startime,start,end,hour,cnt,session;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     int limit = Bars-counted_bars;
     if(limit>Bars-24){limit=Bars-24;}
  //---- main loop
     for (int i=limit; i >= 0; i--)
     {
      session=session(i);
   
     if(session==1)
     {
      for(cnt=i;session(cnt)!=2;cnt++)
      {
       if(session(cnt)==3)
       {
        if(session(cnt-1)==1)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==2)
     {
      for(cnt=i;session(cnt)!=3;cnt++)
      {
       if(session(cnt)==1)
       {
        if(session(cnt-1)==2)
        {
         close=cnt;
         high=cnt;
         low=cnt;         
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==3)
     {
      for(cnt=i;session(cnt)!=1;cnt++)
      {
       if(session(cnt)==2)
       {
        if(session(cnt-1)==3)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     pivot=(High[high]+Low[low]+Close[close])/3.0;
     
     ExtMapBuffer1[i]=pivot; 
    // ExtMapBuffer2[i]=high*Point+198;
    // ExtMapBuffer3[i]=High[28];
    }   
     return(0);
    }
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+